#include "../skelgis/skelgis.hpp"

using namespace skelgis;

//-------------------------------------------------------------------------------
BEGINApplyUnary(laplacien, m, double,1, m2, double,1)
//-------------------------------------------------------------------------------
{
  double a = 0.05;
  iterator_cont<double,1> it = m.begin_cont();
  iterator_cont<double,1> itEnd = m.end_cont();

  for(it; it<itEnd; ++it)
    {
      double val = m[it];
      double res = (1-4*a)*val+a*(m.getRight(it)+
				  m.getLeft(it)+
				  m.getUp(it)+
				  m.getDown(it));
      m2[it] = res;
    }
}
END(laplacien)
//-------------------------------------------------------------------------------

//-------------------------------------------------------------------------------
int main(int argc, char** argv)
//-------------------------------------------------------------------------------
{
  INITSKELGIS;

  HEADER head;
  head.x=0;
  head.y=0;
  head.width=100;
  head.height=100;
  head.spacing=1;
  head.nodata=-9999;

  DMatrix<double,1> m(head,0);
  m.setGlobalMiddleValue(1);
  DMatrix<double,1> m2(head,0);

  for(int i=0;i<100;i++)
    {
      ApplyUnary<double,1,double,1>::apply(laplacien,m,m2);
      DMatrix<double,1> m3(m);
      m = m2;
      m2 = m3;
    }

  ENDSKELGIS;
}
//-------------------------------------------------------------------------------
