#include "../skelgis/skelgis.hpp"

using namespace skelgis;

//-------------------------------------------------------------------------------
//PARAMETERS LIST
//-------------------------------------------------------------------------------
BEGINParam(param)
bool up;
ENDParam(param)

//-------------------------------------------------------------------------------
struct _ApplyListDDAG_test_list : public _ApplyListDDAG_Func<DPMap_Nodes<DDAG<true,true>,double,0>, DPMap_Edges<DDAG<true,true>,double,1>, DPMap_Nodes<DDAG<true,true>,double,0>, DPMap_Edges<DDAG<true,true>,double,1> >
//-------------------------------------------------------------------------------
{
  void operator()(DPMap_vector<DPMap_Nodes<DDAG<true,true>,double,0> >& v1, DPMap_vector<DPMap_Edges<DDAG<true,true>,double,1> >& v2, 
		  DPMap_vector<DPMap_Nodes<DDAG<true,true>,double,0> >& v3, DPMap_vector<DPMap_Edges<DDAG<true,true>,double,1> >& v4 ) const
    {
      //get DPMaps from vectors
      DPMap_Nodes<DDAG<true,true>,double,0> temp = v1[0];
      DPMap_Edges<DDAG<true,true>,double,1> Q1 = v2[0];
      DPMap_Edges<DDAG<true,true>,double,1> Qn = v2[1];

      //root case on ly one for this case
      iterator_dag it = temp.begin_roots();
      iterator_dag itEnd = temp.end_roots();
      //compute value depending of the iteration number
      //input signal
      for(it;it<itEnd;++it)
      {
	       if(PARAM(param,up)==true)
	         temp[it] = 1;
	       else
	         temp[it] = 0;
      }

      //normal elements
      iterator_dag it2 = temp.begin();
      iterator_dag it2End = temp.end();
      for(it2;it2<it2End;++it2)
	     {
	       //list of in edges
	       std::vector<iterator_dag> in_ed = temp.getInEdges(it2);
	       //list of out edges
	       std::vector<iterator_dag> out_ed = temp.getOutEdges(it2);
	  
	       //compute sum and divide
	       double comp = 0;
	       for(int j=0;j<in_ed.size();j++)
	         comp += Qn[in_ed[j]];
	       comp = comp / out_ed.size();

	       //write result in temp
	       temp[it2] = comp;
	     }

      //leafs nothing

      //edges computation
      iterator_dag it3 = Q1.begin();
      iterator_dag it3End = Q1.end();
      for(it3;it3<it3End;++it3)
	     {
	       Q1[it3] = temp[Q1.getSrcNode(it3)];
	       Qn[it3] = Q1[it3];
	     }
    }
}passingModel;
//-------------------------------------------------------------------------------

//-------------------------------------------------------------------------------
int main(int argc, char** argv)
//-------------------------------------------------------------------------------
{
  INITSKELGIS;

  typedef DDAG<true,true> dag_type;
  dag_type tr(argv[1]);

  typedef DPMap_Edges<dag_type,double,1> dpmap_edges_type;
  dpmap_edges_type Q1(tr,0.0);
  dpmap_edges_type Qn(tr,0.0);

  typedef DPMap_Nodes<dag_type,double,0> dpmap_nodes_type;
  dpmap_nodes_type temp(tr,0.0);

  for(int i=0;i<10000;i++)
    {
      if(i%2==0 && PARAM(param,up)==false)
	       PARAM(param,up)=true;
      else if(i%2==0 && PARAM(param,up)==true)
	       PARAM(param,up)=false;
      
      //call to applyListDDAG with function passingModel
      DPMap_vector<dpmap_nodes_type> v1;
      v1.push_back(temp);
      DPMap_vector<dpmap_edges_type> v2;
      v2.push_back(Q1);
      v2.push_back(Qn);

      ApplyListDDAG(passingModel,v1,v2,v1,v2);
    }

  ENDSKELGIS;
  return 0;
}
//-------------------------------------------------------------------------------
