/*! \file write.hpp
 *  \brief functions to write output files
 */
#ifndef DPMAP_WRITE_H
#define DPMAP_WRITE_H

#include "../data_structures/DDAG/ddag.hpp"
#include "../data_structures/DDAG/dpmap_edges.hpp"
#include "../data_structures/DDAG/dpmap_nodes.hpp"
#include "../iterators/DDAG/iterator.hpp"

#include <iomanip> 

//#include "../data_structures/DMatrix/dmatrix.hpp"
//#include "../iterators/DMatrix/iterator.hpp"

namespace skelgis{

  //-------------------------------------------------------------------------------
  //!  write three dpmap_edge
  /*!
    \param 
  */
  //-------------------------------------------------------------------------------
  template<class DD, class T1, class T2, class T3> void write_dpmap(std::string filename,DD &dag,T1 &dp1,T2 &dp2, T3 &dp3)
  //-------------------------------------------------------------------------------
  {
    iterator_dag it = dp1.begin();
    iterator_dag itEnd = dp1.end();
    for(it;it<itEnd;++it)
      {
	std::stringstream st;
	st<<"outputs/"<<filename<<"_"<<dag.getIndexEdge(it._rank)<<".dat";
	std::ofstream outfile(st.str().data(),std::ofstream::out);

	double size = dp1.getDataSize(it);
	double * dp1d = dp1[it];
	double * dp2d = dp2[it];
	double * dp3d = dp3[it];
	std::stringstream outst;
	for(int i=0;i<size;i++)
	  outst<<std::setprecision(25)<<dp1d[i]<<"\t"<<dp2d[i]<<"\t"<<dp3d[i]<<"\n";

	outfile.write(outst.str().data(),outst.str().size());
	outfile.close();
      }
  }
  //-------------------------------------------------------------------------------


};

#endif
